diff --git a/lib/hipe/main/hipe.erl b/lib/hipe/main/hipe.erl
index b278997..cbf6535 100644
--- a/lib/hipe/main/hipe.erl
+++ b/lib/hipe/main/hipe.erl
@@ -766,7 +766,7 @@ finalize_fun_concurrent(MfaIcodeList, Exports, Opts) ->
       NonEscaping = [MFA || {{_M, F, A} = MFA, Icode} <- MfaIcodeList, 
 			    not lists:member({F, A}, Exports),
 			    not hipe_icode:icode_is_closure(Icode)],
-      Escaping = Closures ++ Exported,
+      Escaping = fix_escaping(lists:sort(Closures ++ Exported)),
       TypeServerFun =
 	fun() ->
 	    hipe_icode_coordinator:coordinate(CallGraph, Escaping,
@@ -804,6 +804,12 @@ finalize_fun_concurrent(MfaIcodeList, Exports, Opts) ->
       []
   end.
 
+fix_escaping([{MFA,false},{MFA,true}|T]) ->
+  [{MFA,true}|fix_escaping(T)];
+fix_escaping([H|T]) ->
+  [H|fix_escaping(T)];
+fix_escaping([]) -> [].
+
 stop_and_wait(Pid) ->
   Pid ! {stop, self()},
   receive
